//+------------------------------------------------------------------+
//|                                                 rsi with rsi.mq4 |
//|                                                                  |
//| TASC January 2011 Peter Konne article "Combining Rsi With Rsi"   |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  DeepSkyBlue
#property indicator_color2  PaleVioletRed
#property indicator_color3  DeepSkyBlue
#property indicator_color4  PaleVioletRed
#property indicator_width1  4
#property indicator_width2  4
#property indicator_width3  1
#property indicator_width4  1

//
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern int    RsiShort        = 5;
extern int    RsiLong         = 17;
extern int    RsiPrice        = PRICE_CLOSE;
extern double RsiLevelUp      = 60;
extern double RsiLevelDown    = 40;
extern int    MaShortPeriod   = 10;
extern int    MaLongPeriod    = 40;
extern int    MaPrice         = PRICE_CLOSE;
extern bool   AlertsOn        = false;
extern bool   AlertsOnLevel1  = true;
extern bool   AlertsOnLevel2  = true;
extern bool   AlertsOnCurrent = true;
extern bool   AlertsMessage   = true;
extern bool   AlertsSound     = false;
extern bool   AlertsEmail     = false;


//
//
//
//
//

double signallUp[];
double signallDn[];
double signalsUp[];
double signalsDn[];
double trend1[];
double trend2[];

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
      SetIndexBuffer(0,signallUp); SetIndexStyle(0,DRAW_ARROW); SetIndexArrow(0,159);
      SetIndexBuffer(1,signallDn); SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,159);
      SetIndexBuffer(2,signalsUp); SetIndexStyle(2,DRAW_ARROW); SetIndexArrow(2,251);
      SetIndexBuffer(3,signalsDn); SetIndexStyle(3,DRAW_ARROW); SetIndexArrow(3,251);
      SetIndexBuffer(4,trend1);
      SetIndexBuffer(5,trend2);
   
      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         calculateValue    = TimeFrame=="calculateValue";   if (calculateValue) { return(0); }
         returnBars        = TimeFrame=="returnBars";       if (returnBars)     { return(0); }
         timeFrame         = stringToTimeFrame(TimeFrame);
      
      //
      //
      //
      //
      //

   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { signallUp[0] = MathMin(limit+1,Bars-1); return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame == Period())
   {
      for(int i=limit; i>=0; i--)
      {
         double range    = iATR(NULL,0,10,i)/2.0;
         double rsiShort = iRSI(NULL,0,RsiShort,RsiPrice,i);
         double rsiLong  = iRSI(NULL,0,RsiLong ,RsiPrice,i);
         double maLong   = iMA(NULL,0,MaLongPeriod ,0,MODE_SMA,MaPrice,i);
         double maShort  = iMA(NULL,0,MaShortPeriod,0,MODE_SMA,MaPrice,i);
         double price    = iMA(NULL,0,1            ,0,MODE_SMA,MaPrice,i);
      
         //
         //
         //
         //
         //
      
         trend1[i] = trend1[i+1]; 
            if (rsiShort>RsiLevelUp)   trend1[i] =  1;
            if (rsiShort<RsiLevelDown) trend1[i] = -1;
         trend2[i] = trend2[i+1]; 
            if (rsiLong>RsiLevelUp)    trend2[i] =  1;
            if (rsiLong<RsiLevelDown)  trend2[i] = -1;

         //
         //
         //
         //
         //
      
      
         signallUp[i] = EMPTY_VALUE;
         signallDn[i] = EMPTY_VALUE;
         signalsUp[i] = EMPTY_VALUE;
         signalsDn[i] = EMPTY_VALUE;
            if (trend1[i]!=trend1[i+1] && trend1[i]== 1 && price > maShort && trend2[i] == -1) signalsUp[i] = Low[i]  - range;  
            if (trend2[i]!=trend2[i+1] && trend2[i]== 1 && price > maLong)                     signallUp[i] = Low[i]  - range*2.0;
            if (trend1[i]!=trend1[i+1] && trend1[i]==-1 && price < maShort && trend2[i] ==  1) signalsDn[i] = High[i] + range;
            if (trend2[i]!=trend2[i+1] && trend2[i]==-1 && price < maLong)                     signallDn[i] = High[i] + range*2.0;
      }      
      manageAlerts();
      return(0);
   }
   
   //
   //
   //
   //
   //

   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit; i>=0; i--)
   {
      signallUp[i] = EMPTY_VALUE;
      signallDn[i] = EMPTY_VALUE;
      signalsUp[i] = EMPTY_VALUE;
      signalsDn[i] = EMPTY_VALUE;
         int y = iBarShift(NULL,timeFrame,Time[i]);
         int x = iBarShift(NULL,timeFrame,Time[i+1]);
         if (x==y) continue;
            signallUp[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RsiShort,RsiLong,RsiPrice,RsiLevelUp,RsiLevelDown,MaShortPeriod,MaLongPeriod,MaPrice,AlertsOn,AlertsOnLevel1,AlertsOnLevel2,AlertsOnCurrent,AlertsMessage,AlertsSound,AlertsEmail,0,y);
            signallDn[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RsiShort,RsiLong,RsiPrice,RsiLevelUp,RsiLevelDown,MaShortPeriod,MaLongPeriod,MaPrice,AlertsOn,AlertsOnLevel1,AlertsOnLevel2,AlertsOnCurrent,AlertsMessage,AlertsSound,AlertsEmail,1,y);
            signalsUp[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RsiShort,RsiLong,RsiPrice,RsiLevelUp,RsiLevelDown,MaShortPeriod,MaLongPeriod,MaPrice,AlertsOn,AlertsOnLevel1,AlertsOnLevel2,AlertsOnCurrent,AlertsMessage,AlertsSound,AlertsEmail,2,y);
            signalsDn[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RsiShort,RsiLong,RsiPrice,RsiLevelUp,RsiLevelDown,MaShortPeriod,MaLongPeriod,MaPrice,AlertsOn,AlertsOnLevel1,AlertsOnLevel2,AlertsOnCurrent,AlertsMessage,AlertsSound,AlertsEmail,3,y);
   }
   return(0);
         
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (AlertsOn)
   {
      if (AlertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;

      //
      //
      //
      //
      //
      
      if (signalsUp[whichBar] != EMPTY_VALUE || signalsDn[whichBar] != EMPTY_VALUE)
      {
         static datetime time1 = 0;
         static string   mess1 = "";
            if (signalsUp[whichBar] != EMPTY_VALUE) doAlert(time1,mess1," rsi-with-rsi level 1 buy signal");
            if (signalsDn[whichBar] != EMPTY_VALUE) doAlert(time1,mess1," rsi-with-rsi level 1 sell signal");
      }
      if (signallUp[whichBar] != EMPTY_VALUE || signallDn[whichBar] != EMPTY_VALUE)
      {
         static datetime time2 = 0;
         static string   mess2 = "";
            if (signallUp[whichBar] != EMPTY_VALUE) doAlert(time2,mess2," rsi-with-rsi level 2 buy signal");
            if (signallDn[whichBar] != EMPTY_VALUE) doAlert(time2,mess2," rsi-with-rsi level 2 sell signal");
      }
   }
}

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[0]) {
       previousAlert  = doWhat;
       previousTime   = Time[0];

       //
       //
       //
       //
       //

       message =  timeFrameToString(Period())+" "+Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+doWhat;
          if (AlertsMessage) Alert(message);
          if (AlertsEmail)   SendMail(Symbol()+" rsi-with-rsi",message);
          if (AlertsSound)   PlaySound("alert2.wav");
   }
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}